# ./addons/eventscripts/showpos/showpos.py

import es
from usermsg import hudhint
from vecmath import vector

class ShowPos(object):
    class Player(object):
        def __init__(self, userid):
            self.userid    = userid
            self.activated = False
        
        def activateLoop(self):
            self.activated = True
        
        def deactivateLoop(self):
            self.activated = False
        
        def velocityLoop(self):
            if self.activated:
                hudhint(self.userid, '[ShowPos] Velocity: %s' % round(vector((float(es.getplayerprop(self.userid, 'CBasePlayer.localdata.m_vecVelocity[0]')), float(es.getplayerprop(self.userid, 'CBasePlayer.localdata.m_vecVelocity[1]')), float(es.getplayerprop(self.userid, 'CBasePlayer.localdata.m_vecVelocity[2]')))).length(), 2))
    
    def __init__(self):
        self.players = {}
    
    def insertUserid(self, userid):
        self.players[str(userid)] = self.Player(userid)
    
    def removeUserid(self, userid=0, clear=False):
        if not clear:
            del self.players[userid]
        else:
            self.players.clear()
    
    def playerSpawn(self, userid):
        if userid in self.players:
            self.players[userid].activateLoop()
    
    def playerDeath(self, userid):
        self.players[userid].deactivateLoop()
    
    def scriptLoad(self):
        for userid in es.getUseridList():
            self.insertUserid(userid)
        es.ServerVar('showpos_ver', 1.5, "BackRaw's ShowPos")
        es.addons.registerTickListener(self._tickListener)
    
    def scriptUnload(self):
        self.removeUserid(clear=True)
        es.addons.registerTickListener(self._tickListener)
    
    def _tickListener(self):
        for userid in self.players:
            self.players[userid].velocityLoop()

showpos = ShowPos()

def player_activate(ev):
    showpos.insertUserid(ev['userid'])

def player_spawn(ev):
    if int(ev['es_userteam']) > 1:
        showpos.playerSpawn(ev['userid'])

def player_death(ev):
    showpos.playerDeath(ev['userid'])

def player_disconnect(ev):
    showpos.removeUserid(ev['userid'])

def load(): 
    showpos.scriptLoad()

def unload():
    showpos.scriptUnload()
